<?php

namespace Drupal\prepared_data\Processor;

use Drupal\prepared_data\PreparedDataInterface;

/**
 * A basic trait for data processors.
 */
trait ProcessorTrait {

  /**
   * Whether the processor is enabled or not.
   *
   * @var bool
   */
  protected $enabled;

  /**
   * Whether the processor is active or not.
   *
   * @var bool
   */
  protected $active;

  /**
   * {@inheritdoc}
   */
  public function isEnabled() {
    return !empty($this->enabled);
  }

  /**
   * {@inheritdoc}
   */
  public function setEnabled($enabled = TRUE) {
    $this->enabled = $enabled;
  }

  /**
   * {@inheritdoc}
   */
  public function isActive() {
    return $this->isEnabled() && !empty($this->active);
  }

  /**
   * {@inheritdoc}
   */
  public function setActive($active = TRUE) {
    $this->active = $active;
  }

  /**
   * {@inheritdoc}
   */
  public function initialize(PreparedDataInterface $data) {
  }

  /**
   * {@inheritdoc}
   */
  public function process(PreparedDataInterface $data) {
  }

  /**
   * {@inheritdoc}
   */
  public function finish(PreparedDataInterface $data) {
  }

  /**
   * {@inheritdoc}
   */
  public function cleanup(PreparedDataInterface $data) {
  }

}
