<?php

namespace Drupal\prepared_data\Shorthand;

/**
 * Interface for shorthand instances of prepared data keys.
 */
interface ShorthandInterface {

  /**
   * Get the shorthand ID.
   *
   * @return string
   *   The shorthand ID.
   */
  public function id();

  /**
   * Get the represented data key.
   *
   * @return string
   */
  public function key();

  /**
   * Get the subset keys.
   *
   * @return string|array
   *   The subset keys, if any.
   */
  public function subsetKeys();

  /**
   * Get the data key and subset keys as encoded Http query.
   *
   * @return string
   *   The data query.
   */
  public function getDataQuery();

}
